# This is a header-only template lib, which has no debugging symbols itself.
%global debug_package %{nil}

# Conditional for release and snapshot builds. Uncomment for release-builds.
# %%global rel_build 1

# Settings used for build from snapshots.
%{!?rel_build:%global commit		818fd25173be68047558691502af99fdca2a9d0c}
%{!?rel_build:%global commit_date	20131001}
%{!?rel_build:%global shortcommit	%(c=%{commit};echo ${c:0:7})}
%{!?rel_build:%global gitver		git%{commit_date}-%{shortcommit}}
%{!?rel_build:%global gitrel		.git%{commit_date}.%{shortcommit}}
%{!?rel_build:%global gittar		%{name}-%{version}-%{gitver}.tar.gz}

%global common_desc								\
Stichwort is a simple tool for C++ keyword arguments.  The library		\
provides rather clean and simple API for creating keywords and handling		\
them as function parameters.

Name:			stichwort
Version:		0.0.3
Release:		0.6%{?gitrel}%{?dist}
Summary:		Simple library for named parameters in C++
%{?el5:Group:		Development/Libraries}

License:		BSD
URL:			https://github.com/lisitsyn/%{name}
# Source for release-builds.
%{?rel_build:Source0:	%{url}/archive/%{version}.tar.gz#/%{name}-%{version}.tar.gz}
# Source for snapshot-builds.
%{!?rel_build:Source0:	%{url}/archive/%{commit}.tar.gz#/%{gittar}}
Source99:		http://googletest.googlecode.com/files/gtest-1.6.0.zip

# Patch is needed on <= el6 (CMake 2.6.X) to fix the testsuite.
Patch0:			stichwort-0.0.3_fix-testsuite-for-CMake-26.patch

%{?el5:BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)}
BuildRequires:		cmake

%description
%{common_desc}


%package devel
Summary:		Simple library for named parameters in C++
%{?el5:Group:		Development/Libraries}

%{!?el5:BuildArch:	noarch}

Provides:		%{name}			=  %{version}-%{release}
Provides:		%{name}-static		=  %{version}-%{release}

%description devel
%{common_desc}


%prep
%setup -q%{!?rel_build:n %{name}-%{commit}}

# Apply patch for fixing testsuite on <= el6 (CMake 2.6.X).
%if 0%{?rhel} && 0%{?rhel} <= 6
%patch0 -p1
%endif #0%%{?rhel} && 0%%{?rhel} <= 6

# Setup gtest-1.6.0
unzip -qq %{SOURCE99}

# Create some directories needed in further progress.
mkdir -p build examples

# The test-sources are nice examples.
cp -a test/* examples


%build
pushd build

# We need to have rpath enabled for <= el6.  Otherwise the testsuite will fail.
# Rpath is no problem here, because this is a header-only template-lib.
%cmake										\
	-DBUILD_TESTS=ON							\
%if 0%{?rhel} && 0%{?rhel} <= 6
	-DCMAKE_SKIP_RPATH:BOOL=OFF						\
%endif #0%%{?rhel} && 0%%{?rhel} <= 6
	..
make %{?_smp_mflags}
popd


%install
%{?el5:rm -rf %{buildroot}}

# No `make install`-target available.  We need to install manually.
mkdir -p %{buildroot}%{_includedir}
cp -a include/%{name} %{buildroot}%{_includedir}
chmod 0644 %{buildroot}%{_includedir}/%{name}/*


%check
pushd build
ctest %{?_smp_mflags} --output-on-failure ..
popd


%{?el5:%clean}
%{?el5:rm -rf %{buildroot}}


%files devel
%doc LICENSE README.md examples
%{_includedir}/%{name}


%changelog
* Fri Feb 05 2016 Fedora Release Engineering <releng@fedoraproject.org> - 0.0.3-0.6.git20131001.818fd25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_24_Mass_Rebuild

* Fri Jun 19 2015 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.3-0.5.git20131001.818fd25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_23_Mass_Rebuild

* Mon Aug 18 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.3-0.4.git20131001.818fd25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_22_Mass_Rebuild

* Sun Jun 08 2014 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.0.3-0.3.git20131001.818fd25
- Rebuilt for https://fedoraproject.org/wiki/Fedora_21_Mass_Rebuild

* Mon Dec 23 2013 Björn Esser <bjoern.esser@gmail.com> - 0.0.3-0.2.git20131001.818fd25
- added virtual provides for %%{name}-static

* Mon Dec 23 2013 Björn Esser <bjoern.esser@gmail.com> - 0.0.3-0.1.git20131001.818fd25
- Initial rpm release (#1046078)
